/*======================================================*/
/*  TextDL.c  -  precompiled text using display lists   */
/*                                                      */
/*  Author:  Bary W Pollack                             */
/*  Updated: Apr. 1, 2005                               */
/*======================================================*/

#include <GL/glut.h>
#include <string.h>

/*======================================================*/

void display (void)
{
    char  text[] = "Text message 1";

    glClear (GL_COLOR_BUFFER_BIT);
    glRasterPos2f (-20.0, 40.0);
    glCallLists ((GLuint) strlen (text), GL_UNSIGNED_BYTE, text);

    text [strlen (text) - 1] = '2';
    glRasterPos2f (-20.0, 30.0);
    glCallLists ((GLuint) strlen (text), GL_UNSIGNED_BYTE, text);

    text [strlen (text) - 1] = '3';
    glRasterPos2f (-20.0, 10.0);
    glCallLists ((GLuint) strlen (text), GL_UNSIGNED_BYTE, text);
}

/*======================================================*/

void myinit (void)
{
    int  i;
    GLuint base;

    glClearColor (0.1, 0.1, 0.4, 1.0);
    glColor3f (1.0, 1.0, 1.0);

    /* create the display lists for all 256 characters */
    base = glGenLists (256);
    for (i = 0; i < 256; i++)
    {
        glNewList (base + i, GL_COMPILE);
            glutBitmapCharacter (GLUT_BITMAP_HELVETICA_18, i);
        glEndList ();
    }
    glListBase (base);
}

/*======================================================*/

void myReshape (int w, int h)
{
    glViewport (0, 0, w, h);
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
    if (w <= h) 
        glOrtho (-50.0, 50.0, -50.0 * (GLfloat) h / (GLfloat) w, 
                               50.0 * (GLfloat) h / (GLfloat) w, -1.0, 1.0);
    else 
        glOrtho (-50.0 * (GLfloat) w / (GLfloat) h, 
                  50.0 * (GLfloat) w / (GLfloat) h, -50.0, 50.0, -1.0, 1.0);
    glMatrixMode (GL_MODELVIEW);
}

/*======================================================*/

int main (int argc, char** argv)
{
    glutInit (&argc, argv);

    glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
    glutInitWindowSize (300, 300);
    glutInitWindowPosition (300, 150);
    glutCreateWindow ("Text2");
    myinit ();
    glutDisplayFunc (display);
    glutReshapeFunc (myReshape);

    glutMainLoop ();

    return 0;
}

/*======================================================*/
